CKEDITOR.plugins.add( 'gadget', {
	icons: 'gadget',
	lang: 'nl,en',
	onLoad: function()
	{
		// add css to the editor for the gadget placeholder
		CKEDITOR.addCss( 'img.cke_gadget' +
			'{' +
				'background-image: url(' + CKEDITOR.getUrl( this.path + 'images/placeholder.png' ) + ');' +
				'background-position: center center;' +
				'background-repeat: no-repeat;' +
				'border: 1px solid #a9a9a9;' +
				'min-width: 50px;' +
				'min-height: 50px;' +
			'}'
		);
	},
	init: function( editor )
	{
		// add a command and toolbar button
		editor.addCommand( 'gadget', new CKEDITOR.dialogCommand( 'gadgetDialog' ) );
		editor.ui.addButton( 'gadget', {
			label: editor.lang.gadget.addGadget,
			command: 'gadget',
			toolbar: 'insert'
		});

		// when a gadget is right-clicked, add a context-menu entry
		if( editor.contextMenu )
		{
			editor.addMenuGroup( 'gadgetGroup' );
			editor.addMenuItem( 'gadgetItem', {
				label: editor.lang.gadget.editGadget,
				icon: this.path + 'icons/gadget.png',
				command: 'gadget',
				group: 'gadgetGroup'
			});

			editor.contextMenu.addListener( function( element )
			{
				if( element && element.is( 'img' ) && !element.isReadOnly() && element.data( 'cke-real-element-type' ) == 'gadget' )
					return { gadgetItem: CKEDITOR.TRISTATE_OFF };
			});
		}

		// add the gadget dialog
		CKEDITOR.dialog.add( 'gadgetDialog', this.path + 'dialogs/gadget.js' );
	},
	afterInit: function( editor )
	{
		var dataProcessor = editor.dataProcessor,
			dataFilter = dataProcessor && dataProcessor.dataFilter;

		// add a datafilter, to replace all gadgets with fake elements.
		if( dataFilter )
		{
			dataFilter.addRules(
			{
				elements: {
					'div': function( element )
					{
						if( /gadgetPlugin/g.test( element.attributes['class'] ) !== true )
							return null;

						var extraClasses = $.trim( element.attributes['class'].replace( /gadgetPlugin/g, '' ) );
						return editor.createFakeParserElement( element, 'cke_gadget ' + extraClasses, 'gadget', true );
					}
				}
			}, 5 );
		}
	}
});